function createCanvas(width, height, className) {
    
    var canvas = document.createElement("canvas");
    
    canvas.width = width;
    canvas.height = height;
    canvas.className = className;
    
    document.getElementById("wrapper").appendChild(canvas);
    
    return canvas;
}


// use a pseudo-random generator to produce reproducible results for testing

var seed = 1050;
function resetRandom() {
    seed = 1050;
}
function random() {
    var x = Math.sin(seed++) * 10000;
    return x - Math.floor(x);
}

function randomGaussian() {
    // Pseudo-Gaussian distributed random number, generated by repeated picking and averaging
    // Returns numbers in the range -1 .. +1 !
    
    var rand = 0;
    var num = 5;

    for (var i = 0; i < num; i += 1) {
        rand += random();
    }

    return rand / num * 2 - 1;
}

function createDrawCanvas(width, height, moveCallback, clickCallback) {
    
    var canvas = createCanvas(width, height);
    var ctx = canvas.getContext("2d");
    
    var drawCanvas = {};
    
    var zoom = 1;
    
    drawCanvas.drawPixel = function(x, y, color) {
        x = Math.round(x);
        y = Math.round(y);
        color = color || "#000000";
        ctx.save();
        ctx.fillStyle = color;
        ctx.fillRect(x, y, 1, 1);
        ctx.restore();
    }
    drawCanvas.drawLine = function(p1, p2, color, width) {
        ctx.save();
        ctx.fillStyle = "transparent";
        ctx.strokeStyle = color || "#dddddd";
        ctx.lineWidth = width || 1;
        ctx.lineCap = "round";
        ctx.beginPath();
        ctx.moveTo(p1[0], p1[1]);
        ctx.lineTo(p2[0], p2[1]);
        ctx.stroke();
        ctx.restore();
    }
    drawCanvas.drawQuadraticBezier = function(p1, p2, cp, color, width) {
        ctx.save();
        ctx.fillStyle = "transparent";
        ctx.strokeStyle = color || "#dddddd";
        ctx.lineWidth = width || 1;
        ctx.lineCap = "round";
        ctx.beginPath();
        ctx.moveTo(p1[0], p1[1]);
        ctx.quadraticCurveTo(cp[0], cp[1], p2[0], p2[1]);
        ctx.stroke();
        ctx.restore();
    }
    drawCanvas.fillPolygon = function(points, fillColor) {
        ctx.save();
        ctx.fillStyle = fillColor || "#dddddd"; //randomColor();
        ctx.strokeStyle = "transparent";
        ctx.beginPath();
        ctx.moveTo(points[0][0], points[0][1]);
        points.forEach(function(p) {
            ctx.lineTo(p[0], p[1]);
        });
        ctx.closePath();
        ctx.fill();
        ctx.restore();
    }
    
    drawCanvas.clear = function() {
        ctx.save();
        ctx.fillStyle = "#ffffff";
        ctx.fillRect(0, 0, width, height);
        ctx.restore();   
    }
    
    drawCanvas.drawCursor = function(x, y, size, color) {
        size = size || 10;
        color = color || "#ff0000";
        
        ctx.save();
        ctx.fillStyle = color;
        ctx.beginPath();
        ctx.ellipse(x, y, size/2, size/2, 0, 0, 2 * Math.PI); 
        ctx.fill();        
        ctx.restore(); 
    }

    drawCanvas.drawStatus = function(text) {
        ctx.save();
        ctx.fillStyle = "#000000";
        var textWidth = ctx.measureText(text).width;
        ctx.fillText(text, width - textWidth - 3, height - 3);
        ctx.restore();   
    }

    canvas.addEventListener("click", function(event) {
        var relX = event.clientX - this.offsetLeft + document.documentElement.scrollLeft;
        var relY = event.clientY - this.offsetTop + document.documentElement.scrollTop;
        relX = Math.ceil(relX / zoom) - 1;
        relY = Math.ceil(relY / zoom) - 1;
        clickCallback.call(ctx, relX - 1, relY - 1);
    });
    canvas.addEventListener("mousemove", function(event) {
        var relX = event.clientX - this.offsetLeft + document.documentElement.scrollLeft;
        var relY = event.clientY - this.offsetTop + document.documentElement.scrollTop;
        relX = Math.ceil(relX / zoom) - 1;
        relY = Math.ceil(relY / zoom) - 1;
        // move point a bit so it is not directly under the mouse
        moveCallback.call(ctx, relX - 1, relY - 1);
    });
    return drawCanvas;
}

var SIZE = SIZE || 450;

var canvas = [];
for (var i=0; i<lineDrawingFunctions.length; i++) {
    var canv = createDrawCanvas(SIZE, SIZE, moveCallback, clickCallback);
    canv.drawFunc = lineDrawingFunctions[i];
    canv.line = true;
    canvas.push(canv);
}
/*
for (var i=0; i<polygonDrawingFunctions.length; i++) {
    var canv = createDrawCanvas(SIZE, SIZE, moveCallback, clickCallback);
    canv.drawFunc = polygonDrawingFunctions[i];
    canvas.push(canv);
}
*/

var drawLine = function(){};
var fillPoly = function(){};

function setCanvas(canvas) {
    drawLine = canvas.drawLine;
    drawQuadraticBezier = canvas.drawQuadraticBezier;
    fillPolygon = canvas.fillPolygon;
}

function clear() {
    for (var i=0; i<canvas.length; i++) {
        canvas[i].clear();
    }
    canvas_zoom.clear();
}

function deg_rad(ang) {
    return ang * (Math.PI/180.0);
}

function projectMercator(lonlat) {
    var lat = deg_rad(lonlat[1]);
    var lng = deg_rad(lonlat[0]);
    var x = lng / 2.0 / Math.PI + 0.5;
    var y = Math.log((Math.sin(lat) + 1.0) /
          Math.cos(lat)) / 2.0 / Math.PI + 0.5;
    return [x, y];
}

function drawPolyline(coordinates, drawFunc, properties) {
    for (var i=0; i<coordinates.length-1; i++) {
        var prev = i>0 ? coordinates[i-1] : null;
        var next = i<coordinates.length-2 ? coordinates[i+2] : null;
        drawFunc(coordinates[i], coordinates[i+1], prev, next);
    }
}

var points = [];
var NUM_LINES = NUM_LINES || 5;

function clear() {
    for (var i=0; i<canvas.length; i++) {
        canvas[i].clear();
    }
}

function drawCross(x, y, radius, color) {
    drawPixel(x - radius, y, color);
    drawPixel(x + radius, y, color);
    drawPixel(x, y - radius, color);
    drawPixel(x, y + radius, color);
}


function moveCallback(x, y) {
    
    clear();

    points.pop();
    points.push([x,y]);
    
    drawAll();
    
    for (var i=0; i<canvas.length; i++) {       
        canvas[i].drawCursor(x, y, 10, "#ff0000");
    }
}

function clickCallback(x,y) {
    points.push([x,y]);
    if (points.length > (NUM_LINES+2)) points = points.slice(-(NUM_LINES+2));
    clear();
    drawAll();
}
   

function drawAll(data) {
    
    resetRandom();
    
    var projectedFeatures = [];
    var minX = 1, maxX = 0, minY = 1, maxY = 0;
    
    for (var i=0; i<canvas.length; i++) {
        
        setCanvas(canvas[i]);        

        var drawFunc = window[canvas[i].drawFunc];
        
        if (canvas[i].line) {
            drawPolyline(points, drawFunc);
        }
        else {
            projectedFeatures.forEach(function(poly){
                drawPolyline(poly.coordinates, drawFunc, poly.properties);
            });
        }
        canvas[i].drawStatus(drawFunc.name);
    }    
}




